package enquete.model;
/*
 * Historico:
 *    24/03/2003: rodrigor - Criao da classe
 */

import java.util.EventListener;

/**
 * Interface Listener para receber eventos da EnqueteSimples.
 * Toda classe interessada em processar os eventos lanados pela Enquete
 * deve implementar esta interface e se cadastrar no objeto EnqueteSimples
 * usando o mtodo addEnqueteListener().<br>
 * O metodo novoVoto() sera chamado quando um novo voto for contabilizado na Enquete.
 * O mtodo novaOpcao() ser chamado quando uma nova opo for adicionada na Enquete.
 *
 * @author <a href="mailto:rodrigor@dsc.ufcg.edu.br">Rodrigo Rebouas de Almeida</a>
 * @since 24/03/2003
 **/
public interface EnqueteListener extends EventListener {


	/**
	 * Infocado quando um novo voto  contabilizado na Enquete.
	 * @param event Evento gerado pela Enquete.
	 */
	public void novoVoto(EnqueteEvent event);

	/**
	 * Invocado quando uma nova opo  adicionada  Enquete.
	 * @param event Evento gerado pela Enquete.
	 */
	public void novaOpcao(EnqueteEvent event);
}
