package enquete.view;

/*
 * Historico:
 *    24/03/2003: rodrigor - Criao da classe
 *    25/03/2003: rodrigor - Alterao do construtor: Agora recebe o controller
 *    26/03/2003: rodrigor - Alterado o mtodo novaOpcao()
 *                           Este mtodo foi adaptado s alteraes no objeto
 *                           EnqueteEvent.
 *    31/03/2003: rodrigor - Alterei o construtor para receber um ActionListener
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import enquete.controller.*;
import enquete.model.*;

/**
 * Esta janela  usada para efetivar o voto em alguma das opes disponveis
 * na enquete.
 *
 * @author <a href="mailto:rodrigor@dsc.ufcg.edu.br">Rodrigo Rebouas de Almeida</a>
 * @since 24/03/2003
 **/
public class TelaVotacao extends Frame implements EnqueteListener{


	private Collection botoes = new Vector();

	private ActionListener controller;

	public TelaVotacao(ActionListener controller){
		super("Tela de Votao - Enquete");
		this.setSize(100,120);
		this.setLayout(new GridLayout(0,1)); // Grid com qualquer numero
											  // de linhas e uma coluna
		this.controller = controller;
	    this.addWindowListener(new WindowAdapter() {
	        public void windowClosing(WindowEvent e) {
	        	e.getWindow().hide();
	        	System.exit(0);
	        }
	    });
	}

	/**
	 * @see enquete.model.EnqueteListener#novaOpcao(EnqueteEvent)
	 */
	public void novaOpcao(EnqueteEvent event) {
		String opcao = event.getOpcao();
		Button botao;

		if(!botoes.contains(opcao)){
			botoes.add(opcao);
			botao = new Button(opcao);
			botao.setActionCommand(opcao);
			botao.addActionListener(controller);
			this.add(botao);
		}
	}

	/**
	 * @see enquete.model.EnqueteListener#novoVoto(EnqueteEvent)
	 */
	public void novoVoto(EnqueteEvent event) {
		// Nothing to do
	}

}
