package factory.clients;

import java.rmi.RemoteException;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;
import java.util.Properties;

import factory.manage_orders.ManageOrders;
import factory.manage_orders.ManageOrdersHome;

public class CreateProducts
{
  public static void main(String[] args)
  {
    try
    {
      ContextPropertiesFactory factory = new ContextPropertiesFactory();
      Properties prop = factory.getInitialContextProperties();
      InitialContext initial = new InitialContext(prop);
      //InitialContext initial = new InitialContext();

      Object homeObject = initial.lookup("ManageOrders");

      ManageOrdersHome home = (ManageOrdersHome)
            PortableRemoteObject.narrow(homeObject, 
                                        ManageOrdersHome.class);

      ManageOrders manageOrders = home.create();

      manageOrders.createSampleProducts();
    }
    catch(RemoteException re)
    {
      re.printStackTrace();
    }
    catch(NamingException ne)
    {
      ne.printStackTrace();
    }
    catch(CreateException ce)
    {
      ce.printStackTrace();
    }
  }
}
