package factory.manage_orders;

import javax.ejb.*;
import java.util.Date;
import java.rmi.RemoteException;
import factory.order.OrderNotCancelableException;

public interface ManageOrders extends EJBObject
{
  void placeOrder(int salesDivision, int orderNumber,
                  String product, Date dateDue)
       throws RemoteException, NoSuchProductException,
              DuplicateOrderException;

  void cancelOrder(int salesDivision, int orderNumber)
       throws RemoteException, NoSuchOrderException,
              OrderNotCancelableException;

  OverdueOrderView[] getOverdueOrders() throws RemoteException;

  OpenOrderView[] getSchedulableOrders() throws RemoteException;

  void createSampleProducts() throws RemoteException;

  void createProduct(String id, String name) throws RemoteException;

  void addRoutingInstruction(String id, int sequence, String instruction)
       throws RemoteException;
}
