package factory.manufacture;

import javax.ejb.*;
import java.rmi.RemoteException;
import factory.manage_orders.OpenOrderView;
import factory.manage_orders.NoSuchOrderException;

public interface Manufacture extends EJBObject
{
  OpenOrderView[] getOpenOrders() throws RemoteException;

  void selectForManufacture(int salesDivision, int order_number)
       throws RemoteException, NoSuchOrderException, BadStatusException;

  boolean hasNextRouting() throws RemoteException, NoSelectionException;

  String getNextRouting() throws RemoteException, NoSelectionException;

  void ship(String carrier, int loading_dock) 
       throws RemoteException, NoSelectionException; 
}
