package p1.aplic.cartastestes;

import junit.framework.*;
import p1.aplic.cartas.*;
import java.util.*;

/**
 * Testes da classe Baralho.
 *
 */
public class TestaBaralho extends TestCase {
	protected Baralho  b1; // fica intacto

	public TestaBaralho(String name) {
		super(name);
	}
	public static void main(String[] args) {
		junit.textui.TestRunner.run (suite());
	}
	protected void setUp() {
        b1 = new Baralho();
	}
	public static Test suite() {
		return new TestSuite(TestaBaralho.class);
	}
	public void testNmeroDeCartas() {
        assertEquals(1, b1.menorValor());
        assertEquals(13, b1.maiorValor());
        assertEquals(52, b1.nmeroDeCartas());
    }
	public void testBaralhoNovo() {
        assertTrue(baralhoEstCompleto(b1));
    }
	public void testBaralhar() {
        Baralho b2 = new Baralho();
        b2.baralhar();
        assertTrue(baralhoEstCompleto(b2));
    }
    public boolean baralhoEstCompleto(Baralho b) {
        Vector cartasJVistas = new Vector();
        Iterator it = b.iterator();
        while(it.hasNext()) {
            Carta c = (Carta)it.next();
            // v se carta est ok
            int v = c.getValor();
            int n = c.getNaipe();
            assertTrue("Valor no ok", v >= c.menorValor() && v <= c.maiorValor());
            assertTrue("Naipe no ok", n >= c.primeiroNaipe() && n <= c.ltimoNaipe());
            assertTrue("Carta j vista", !cartasJVistas.contains(c));
            cartasJVistas.add(c);
        }
        return cartasJVistas.size() == 52;
    }
	public void testPegaCarta() {
        Vector cartasJVistas = new Vector();
        Baralho b3 = new Baralho();
        Carta c;
        while((c = b3.pegaCarta()) != null) {
            // v se carta est ok
            int v = c.getValor();
            int n = c.getNaipe();
            assertTrue("Valor no ok", v >= c.menorValor() && v <= c.maiorValor());
            assertTrue("Naipe no ok", n >= c.primeiroNaipe() && n <= c.ltimoNaipe());
            assertTrue("Carta j vista", !cartasJVistas.contains(c));
            cartasJVistas.add(c);
        }
        assertEquals("Baralho no vazio", 0, b3.nmeroDeCartas());
    }
}