/*
 * Desenvolvido para a disciplina Programacao 1
 * Curso de Bacharelado em Cincia da Computao
 * Departamento de Sistemas e Computao
 * Universidade Federal da Paraba
 *
 * Copyright (C) 2001 Universidade Federal da Paraba.
 * No redistribuir sem permisso.
 */
package p1.aplic.correio;

import p1.aplic.geral.*;
import java.io.*;

/**
 * Classe que representa uma mensagem textual de correio eletronico mas que se auto-destroi depois de lida.
 *
 * @author   Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.1
 * <br>
 * Copyright (C) 2001 Universidade Federal da Paraba.
 */

public class MensagemMissaoImpossivel extends MensagemTexto {
  static final long serialVersionUID = 7693744891877165882L;
  /**
   * Cria uma mensagem textual de correio eletrnico
   * @param remetente O remetente da mensagem
   * @param assunto O assunto da mensagem
   * @param contudo O contedo da mensagem, podendo conter vrias linhas
   */
  public MensagemMissaoImpossivel(String remetente, String assunto, String contedo) {
    super(remetente, assunto, contedo);
  }

  /**
   * Exibir a mensagem. Os dados da mensagem so apresentados na sada padro.
   * Aps este mtodo, a mensagem se auto-destroi.
   */
  public void exibir() {
    super.exibir();
    excluir();
  }

  /**
   * Testa a igualdade de um objeto com esta mensagem.
   * @param objeto O objeto a comparar com esta mensagem.
   * @return true se o objeto for igual a esta mensagem, false caso contrrio.
   */
  public boolean equals(Object objeto) {
    if(! (objeto instanceof MensagemMissaoImpossivel)) {
      return false;
    }
    MensagemMissaoImpossivel outra = (MensagemMissaoImpossivel)objeto;
    return super.equals(objeto);
  }
}
