package jogocartas;

import java.util.Collection;
import java.util.ArrayList;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2003
 * Company:
 * @author
 * @version 1.0
 */

public class Application{

  private Collection documents;

  public Application() {
    this.documents = new ArrayList();
  }

  public void add (Document document){
    this.documents.add(document);
  }

  public MenuItem createMenuItem(String label, Command command){
    return new MenuItem(label, command);
  }

  public Menu createMenu(){
    return new Menu();
  }

 public static void main(String[] args){

    Application application = new Application();
    Menu menu = application.createMenu();

    Command openCommand = new OpenCommand(application);
    Command pasteCommand = new PasteCommand(new Document("File1.doc"));
    MacroCommand macroCommand = new MacroCommand();

    macroCommand.add(openCommand);
    macroCommand.add(pasteCommand);

    MenuItem openItem = application.createMenuItem("Open", openCommand);
    MenuItem pasteItem = application.createMenuItem("Paste", pasteCommand);
    MenuItem macroItem = application.createMenuItem("Macro", macroCommand);

    menu.add(openItem);
    menu.add(pasteItem);
    menu.add(macroItem);

    openItem.clicked();
    pasteItem.clicked();
    macroItem.clicked();

  }
}